uva12171 离散化

区间离散化,将1000*1000*1000缩小为最多100*100*100的空间,进行bfs;

#include <cstdio>
#include <string>
#include <iostream>
#include <cstring>
#include <set>
#include <cmath>
#include <algorithm>
#define LL long long
#include <map>
#include <vector>
#define mst(a, b) memset(a, b, sizeof(a))
using namespace std;
const LL MA = 999 * 999 * 999;
struct Node
{
    int x1, y1, z1;
    int x2, y2, z2;
    void GetNode(int a, int b, int c, int d, int e, int f)
    {
        x1 = a; y1 = b; z1 = c;
        x2 = d; y2 = e; z2 = f;
    }

}No[55];
set<int>Set[3]; //x, y, z轴数据集合
int Map[3][105]; // 离散化
int ii[3];
int NumMap[3][1005];
bool G[105][105][105];
bool has[105][105][105];
LL ans1, ans2;
bool is_ok(int a, int b, int c)
{
    return a >= 0 && a < ii[0] && b >= 0 && b < ii[1] && c >= 0 && c < ii[2];
}
void bfs(int x, int y, int z)
{
    if(has[x][y][z]) return;
    has[x][y][z] = true;
    if(!G[x][y][z]) ans1 += (Map[0][x+1] - Map[0][x]) * (Map[1][y+1] - Map[1][y]) * (Map[2][z+1] - Map[2][z]);
    int m1[6] = {0, 0, 0, 0, 1, -1};
    int m2[6] = {0, 0, -1, 1, 0, 0};
    int m3[6] = {-1, 1, 0, 0, 0, 0};
    for(int i = 0; i < 6; i++)
    {
        int a = x + m1[i];
        int b = y + m2[i];
        int c = z + m3[i];
        if(is_ok(a, b, c))
        {
            if(!G[x][y][z] && G[a][b][c])
            {
                LL bb = 0;
                if(m1[i]) bb = abs(Map[1][y+1] - Map[1][y]) * 1LL * abs(Map[2][z+1] - Map[2][z]);
                if(m2[i]) bb = abs(Map[0][x+1] - Map[0][x]) * 1LL * abs(Map[2][z+1] - Map[2][z]);
                if(m3[i]) bb = abs(Map[1][y+1] - Map[1][y]) * 1LL * abs(Map[0][x+1] - Map[0][x]);
//                cout << "bb = " << bb << endl;
                ans2 += bb;
            }
            if(!G[a][b][c])
            bfs(a, b, c);
        }
    }
}
int main()
{
    int t;
    scanf("%d", &t);
    while(t--)
    {
        int n;
        mst(No, 0);
        ans1 = 0;
        ans2 = 0;
        for(int i = 0; i < 3; i++)
        {
            mst(Map[i], 0);
            mst(NumMap[i], 0);
            Set[i].clear();
        }
        for(int i = 0; i < 105; i++)
            for(int j = 0; j < 105; j++)
            {
                mst(G[i][j], false);
                mst(has[i][j], false);
            }
        scanf("%d", &n);
        for(int i = 0; i < n; i++)
        {
            int a, b, c, d, e, f;
            scanf("%d%d%d%d%d%d", &a, &b, &c, &d, &e, &f);
            No[i].GetNode(a, b, c, a+d, b+e, c+f);
            Set[0].insert(a);Set[0].insert(a+d);
            Set[1].insert(b);Set[1].insert(b+e);
            Set[2].insert(c);Set[2].insert(c+f);
        }
        for(int i = 0; i < 3; i++)
        {
            ii[i] = 1;
            Map[i][0] = 1;
            for(set<int>::iterator it = Set[i].begin(); it != Set[i].end(); it++)
            {
                Map[i][ii[i]] = *it;
                NumMap[i][*it] = ii[i];
                ii[i]++;
            }
            Map[i][ii[i]] = 1000;
        }
//        //测试输出
//        for(int i = 0; i < 3; i++)
//            for(int j = 0; j <= ii[i]; j++)
//            printf("%d%c", Map[i][j], j == ii[i] ? ‘\n‘ : ‘ ‘);

        for(int i0 = 0; i0 < n; i0++)
        {
            Node u = No[i0];
            for(int i = NumMap[0][u.x1]; i < NumMap[0][u.x2]; i++)
            {
                for(int j = NumMap[1][u.y1]; j < NumMap[1][u.y2]; j++)
                {
                    for(int k = NumMap[2][u.z1]; k < NumMap[2][u.z2]; k++)
                    {
                        G[i][j][k] = true;
                    }
                }
            }
        }
        bfs(0, 0, 0);
        cout << ans2 << " " << MA - ans1 << endl;
    }
    return 0;

}

时间: 2024-10-05 05:50:16

uva12171 离散化的相关文章

离散化模板

关于离散化, 推荐几篇博客 http://www.matrix67.com/blog/archives/108 http://blog.csdn.net/doyouseeman/article/details/51154142 #include<cstdio> #include<algorithm> using namespace std; int a[10001],date[10001],n; int main() { scanf("%d",&n);

HDU 5925 Coconuts 【离散化+BFS】 (2016CCPC东北地区大学生程序设计竞赛)

Coconuts Time Limit: 9000/4500 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)Total Submission(s): 524    Accepted Submission(s): 151 Problem Description TanBig, a friend of Mr. Frog, likes eating very much, so he always has dreams abou

POJ_2528 Mayor&#39;s poster(线段树+离散化)

题目请点我 题解: 这道题与之前的题目相比重点在于一个映射的预处理,题目所给的区间达到10000000,而最多只有10000个点,如果直接建树的话太过于空旷.把这些区间的左右节点一一对应,最多有4×10000个点,远小于之前的10000000,而且区间之间的对应关系也不会改变. 举个例子: 区间:[2,6],[4,8],[6,10] 我们进行下面对应: 2 4 6 8 10 1 2 3 4 5 则原区间变为[1,3],[2,4],[3,5].可以发现它们之间的覆盖关系并没有改变,但是却紧凑了很多

Codeforces 138C(区间更新+离散化)

题意:有n棵树在水平线上,给出每棵树的坐标和高度,然后向左倒的概率和向右倒的概率,和为1,然后给出了m个蘑菇的位置,每一个蘑菇都有一个魔法值,假设蘑菇被压死了,也就是在某棵树[a[i] - h[i], a[i]) 或 (a[i], a[i] + h[i]]范围内.魔法值就没有了.仅仅有生存下来的蘑菇才有魔法值,问生存下来的蘑菇的魔法值的期望. 题解:能够看到n和m的范围是1e5.而坐标范围是1e9.所以肯定要离散化,然后更新每一个区间的概率值,单点查询每一个蘑菇所在区间的概率值乘其魔法值. #i

求逆序数数目(树状数组+离散化)

404在玩忍者印记(Mark of the Ninja)操纵忍者时遇到这样一个场景,两栋大楼之间有许多绳索,从侧面看,就像这个样子: 我们的忍者非常有好奇心,他可以观察到每个绳索的端点在两栋楼的高度,想知道这些绳索有多少个交点(图中黑色的点).他观察到不会建筑上不会有一点上有两个绳索,并且没有三条绳索共点. 输入描述 第一行:整数T,代表有T组数据. (1 <= T <= 100) 下一行:整数N,代表有N条绳索. (1 <= N <= 100000) 接下来Na行给出两个整数A_

玲珑oj 1117 线段树+离线+离散化,laz大法

1117 - RE:从零开始的异世界生活 Time Limit:1s Memory Limit:256MByte Submissions:438Solved:68 DESCRIPTION 486到了异世界,看到了一群可爱的妹子比如蕾姆啊,艾米莉亚啊,拉姆啊,白鲸啊,怠惰啊等等!有一天膜女告诉486说她的能力可能不能再用了,因为膜女在思考一个数据结构题,没心情管486了.486说我来帮你做,膜女说你很棒棒哦! 给一个集合,最开始为空(不是数学上的集合)五个操作: 1.插入x2.把小于x的数变成x3

Codeforces 490F Treeland Tour(离散化 + 线段树合并)

题目链接 Treeland Tour 题目就是让你求树上LIS 先离散化,然后再线段树上操作.一些细节需要注意一下. #include <bits/stdc++.h> using namespace std; #define rep(i, a, b) for (int i(a); i <= (b); ++i) #define dec(i, a, b) for (int i(a); i >= (b); --i) typedef long long LL; const int N =

51Nod 1515(并查集、set、离散化)

//代码还是YY学姐帮改的,自己从来没有真正A过几道题,不是看题解就是有BUG找不出,多久了还是改变不了这样的现状,或许ACM就是这么筛选人的吧.从5.24到11.24,再到又一年的5.24,可感觉后者比前者过得快多了.多读了一年的大学,完全没有了时间概念,不知道现在到底是大几了,不知道现在到底处在什么位置,不知道毕业后到底从不从事IT这行,一切都是未知的. 题目链接:http://www.51nod.com/onlineJudge/questionCode.html#!problemId=15

ZOJ-2386 Ultra-QuickSort 【树状数组求逆序数+离散化】

Description In this problem, you have to analyze a particular sorting algorithm. The algorithm processes a sequence of n distinct integers by swapping two adjacent sequence elements until the sequence is sorted in ascending order. For the input seque